package project.chongqing.yiyaogaodengzkxx;

import com.hkc.hkcsoft.main.CCDatas;
import com.hkc.hkcsoft.main.CoreControl;
import com.hkc.hkcsoft.main.GlobalData;
import com.hkc.hkcsoft.main.IbatisSqlMapClient;
import com.hkc.hkcsoft.main.OutMsg;
import com.ibatis.sqlmap.client.SqlMapClient;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import project.chongqing.yiyaogaodengzkxx.CancelOrder;
import project.chongqing.yiyaogaodengzkxx.DispFinishT;
import project.chongqing.yiyaogaodengzkxx.ReadDrugInfoThread;
import project.chongqing.yiyaogaodengzkxx.SocketCall;
import project.chongqing.yiyaogaodengzkxx.work.WorkRunThread;
import project.face.FReadOrder;

public class ReadOrderInfoT extends FReadOrder implements Runnable {

   private boolean connState = false;
   private static Connection hisCONN;
   SqlMapClient sqlMap = IbatisSqlMapClient.newInstence();
   public static SocketCall socketCall = new SocketCall();
   HashMap pbdruginfo = new HashMap();


   public ReadOrderInfoT() {
      OutMsg.println("标准：接口表配置参数读取成功：dbType=" + getDbType() + ",dbIP=" + getDbIP() + ",dbName=" + getDbName() + ",dbUserName=" + getDbUserName() + ",dbPWD=" + getDbPWD());
      OutMsg.println("标准：启动与呼叫系统之间的Socket连接");
      socketCall.StartSocket(GlobalData.getCallIP());
   }

   public static void main(String[] args) {
      SqlMapClient sqlMap = IbatisSqlMapClient.newInstence();
      Connection conn = null;

      try {
         conn = sqlMap.getDataSource().getConnection();

         try {
            Statement e = conn.createStatement();
            e.execute("insert into order_info(patient_id,order_no) values(\'1733816\',\'1550197\')");
            conn.commit();
         } catch (Exception var4) {
            var4.printStackTrace();
            conn.rollback();
         }

         Thread.sleep(20000000L);
      } catch (Exception var5) {
         ;
      }

   }

   public boolean createSqlConn() {
      try {
         switch(getDbType()) {
         case 1:
            Class.forName("com.mysql.jdbc.Driver");
            hisCONN = DriverManager.getConnection("jdbc:mysql://" + getDbIP() + ":3306/" + getDbName() + "?useUnicode=true&characterEncoding=utf8", getDbUserName(), getDbPWD());
            break;
         case 2:
            Class.forName("com.microsoft.jdbc.sqlserver.SQLServerDriver");
            hisCONN = DriverManager.getConnection("jdbc:microsoft:sqlserver://" + getDbIP() + ":1433;DatabaseName=" + getDbName(), getDbUserName(), getDbPWD());
            break;
         case 3:
            Class.forName("oracle.jdbc.driver.OracleDriver");
            hisCONN = DriverManager.getConnection("jdbc:oracle:thin:@" + getDbIP() + ":1521:" + getDbName(), getDbUserName(), getDbPWD());
            break;
         case 4:
            Class.forName("oracle.jdbc.driver.OracleDriver");
            hisCONN = DriverManager.getConnection("jdbc:oracle:thin:@" + getDbIP() + ":1521/" + getDbName(), getDbUserName(), getDbPWD());
            break;
         case 5:
            Class.forName("com.ibm.db2.jcc.DB2Driver");
            hisCONN = DriverManager.getConnection("jdbc:db2://" + getDbIP() + ":50000/" + getDbName(), getDbUserName(), getDbPWD());
         case 6:
         case 7:
         case 8:
         default:
            break;
         case 9:
            Class.forName(getDbIP());
            hisCONN = DriverManager.getConnection(getDbName(), getDbUserName(), getDbPWD());
         }

         OutMsg.println("标准：连接到HIS数据库的JDBC连接建立成功:" + hisCONN.toString());
         this.connState = true;
         return true;
      } catch (Exception var2) {
         OutMsg.println(var2);
         OutMsg.println("标准：连接HIS数据库失败！");
         this.connState = false;
         return false;
      }
   }

   public void pbDrugInfoInit() {
      Connection conn = null;

      try {
         conn = this.sqlMap.getDataSource().getConnection();
         PreparedStatement e = conn.prepareStatement("select drug_id from drug_info where use_flag!=?");
         e.setString(1, "1");
         ResultSet rSet_drug = e.executeQuery();

         while(rSet_drug.next()) {
            String drug_id = rSet_drug.getString("drug_id");
            this.pbdruginfo.put(drug_id, drug_id);
         }

         rSet_drug.close();
         e.close();
         conn.close();
      } catch (SQLException var5) {
         OutMsg.println(var5);
      }

   }

   public void run() {
      (new Thread(new WorkRunThread())).start();
      (new Thread(new ReadDrugInfoThread())).start();
      this.pbDrugInfoInit();
      int topID = 0;

      while(!this.connState && !this.createSqlConn()) {
         try {
            Thread.sleep(2000L);
         } catch (InterruptedException var33) {
            var33.printStackTrace();
         }
      }

      Date currentTime = new Date();
      SimpleDateFormat formatter = new SimpleDateFormat("yyyyMMdd");
      String dateString = formatter.format(currentTime);

      try {
         if(CCDatas.sysParamHashMap.get("TOP_ID") == null) {
            (new CoreControl()).createTopID(dateString + "_0");
         } else if(((String)CCDatas.sysParamHashMap.get("TOP_ID")).indexOf(dateString) > -1) {
            topID = Integer.parseInt(((String)CCDatas.sysParamHashMap.get("TOP_ID")).substring(((String)CCDatas.sysParamHashMap.get("TOP_ID")).indexOf("_") + 1));
         }
      } catch (Exception var32) {
         ;
      }

      String noReadID = "\'\'";
      Connection conn = null;

      while(true) {
         Date currentTime1 = new Date();
         dateString = formatter.format(currentTime1);

         while(!this.connState && !this.createSqlConn()) {
            try {
               Thread.sleep(2000L);
            } catch (InterruptedException var27) {
               var27.printStackTrace();
            }
         }

         if(noReadID.split(",").length > 50) {
            noReadID = noReadID.substring(noReadID.indexOf(noReadID.split(",")[noReadID.split(",").length - 50]));
         }

         try {
            Statement e = hisCONN.createStatement();
            String strTopID = String.valueOf(topID);
            String sqlString = "";
            switch(getDbType()) {
            case 1:
               sqlString = getQueryStateSQL().replace("where", "where Pharmacy=\'" + GlobalData.getPharmacyID() + "\' and ").replace("ID>#TOPID#", "(ID>" + strTopID + " or ID in (" + noReadID + "))").replace("#TOPID#", strTopID).replace("to_char(sysdate,\'yyyy-mm-dd\')=to_char(Insert_Time,\'yyyy-mm-dd\')", "DATE_FORMAT(now(),\'%Y%m%d\')=DATE_FORMAT(Insert_Time,\'%Y%m%d\')");
               break;
            case 2:
               sqlString = getQueryStateSQL().replace("where", "where Pharmacy=\'" + GlobalData.getPharmacyID() + "\' and ").replace("ID>#TOPID#", "(ID>" + strTopID + " or ID in (" + noReadID + "))").replace("#TOPID#", strTopID).replace("to_char(sysdate,\'yyyy-mm-dd\')=to_char(Insert_Time,\'yyyy-mm-dd\')", "CONVERT(varchar(12),getdate(),112)=CONVERT(varchar(12),Insert_Time,112)");
               break;
            case 3:
            case 4:
               sqlString = getQueryStateSQL().replace("where", "where Pharmacy=\'" + GlobalData.getPharmacyID() + "\' and ").replace("ID>#TOPID#", "(ID>" + strTopID + " or ID in (" + noReadID + "))").replace("#TOPID#", strTopID);
               break;
            case 5:
            case 9:
               sqlString = getQueryStateSQL().replace("where", "where Pharmacy=\'" + GlobalData.getPharmacyID() + "\' and ").replace("ID>#TOPID#", "(ID>" + strTopID + " or ID in (" + noReadID + "))").replace("#TOPID#", strTopID).replace("to_char(sysdate,\'yyyy-mm-dd\')=to_char(Insert_Time,\'yyyy-mm-dd\')", "date(current　timestamp)=date(Insert_Time)");
            case 6:
            case 7:
            case 8:
            }

            OutMsg.println("执行查询语句为：" + sqlString);

            ResultSet rSet;
            for(rSet = e.executeQuery(sqlString); rSet.next(); (new CoreControl()).updateTopID(dateString + "_" + topID)) {
               int TopID = rSet.getInt("ID");
               String patid = rSet.getString("Patient_ID") == null?rSet.getString("Order_NO"):rSet.getString("Patient_ID");
               int state = rSet.getInt("State");
               String patname = rSet.getString("Patient_Name");
               int windowNO = rSet.getInt("Window_NO");
               String cfxh = rSet.getString("Order_NO");
               String his_operater = "";

               try {
                  his_operater = rSet.getString("His_Operater");
               } catch (Exception var31) {
                  ;
               }

               OutMsg.println("标准：处理ID=" + String.valueOf(TopID) + "的记录 state=" + state);
               switch(state) {
               case 0:
                  OutMsg.println("新开处方：");
                  break;
               case 1:
                  OutMsg.println("标准：处方收费：cfxh=\'" + cfxh + "\' patid=\'" + patid + "\' patname=" + patname + " winno=" + windowNO);
                  conn = this.sqlMap.getDataSource().getConnection();
                  PreparedStatement tempid = conn.prepareStatement("select * from order_info where patient_id=? and order_no=?");
                  tempid.setString(1, patid);
                  tempid.setString(2, cfxh);
                  ResultSet tempi = tempid.executeQuery();
                  if(tempi.next()) {
                     tempi.close();
                     tempid.close();
                     conn.close();
                     OutMsg.println("标准：此患者处方数据已处理过，不在进行处理");
                  } else {
                     tempi.close();
                     tempid.close();
                     OutMsg.println("标准：遍历此患者(" + patid + ")处方(" + cfxh + ")明细，加入order_detail");
                     PreparedStatement prmt3 = conn.prepareStatement("insert into order_detail(patient_id,Order_no,charge_date,Serial_no,Drug_id,Quantity,Order_unit,Set_Manu_no,Use_Once,Use_Dosage,Use_by,Use_Discrip,Use_Frequ,Use_days,Use_Try,His_Stock_Pos,Use_Self,Doctor_Discrip,Use_Times,Price) values(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)");
                     PreparedStatement prmt2 = conn.prepareStatement("insert into order_info(patient_id,order_no,Invoice_NO,Patient_NO,his_id,p_name,recv_date,charge_date,Order_date,win_no,Operator,Doctor_name,Order_Type,Charge_Type,Dept_Name,Disease,sex,age) values(?,?,?,?,?,?,now(),?,?,?,?,?,?,?,?,?,?,?)");
                     int detlnb = 0;
                     Statement statement2 = hisCONN.createStatement();
                     ResultSet rSet2 = statement2.executeQuery("select * from HKC_ORDERDETL_VIEW where Order_NO=\'" + cfxh + "\' and Patient_ID=\'" + patid + "\'");

                     while(rSet2.next()) {
                        if(this.pbdruginfo.get(rSet2.getString("Drug_ID").trim()) == null) {
                           if(detlnb == 0) {
                              prmt2.setString(1, patid);
                              prmt2.setString(2, cfxh);
                              prmt2.setString(3, "");
                              prmt2.setString(4, "");
                              prmt2.setString(5, "");
                              prmt2.setString(6, patname);
                              prmt2.setString(7, rSet2.getString("Charge_Date"));
                              prmt2.setString(8, rSet2.getString("Charge_Date"));
                              prmt2.setInt(9, windowNO);
                              prmt2.setString(10, "");
                              prmt2.setString(11, rSet2.getString("Doctor_Name"));
                              prmt2.setString(12, "");
                              prmt2.setString(13, "");
                              prmt2.setString(14, rSet2.getString("Dept_Name"));
                              prmt2.setString(15, rSet2.getString("Disease"));
                              prmt2.setString(16, rSet2.getString("Sex"));
                              prmt2.setInt(17, rSet2.getInt("Age"));
                           }

                           ++detlnb;
                           prmt3.setString(1, patid);
                           prmt3.setString(2, cfxh);
                           prmt3.setString(3, rSet2.getString("Charge_Date"));
                           prmt3.setString(4, String.valueOf(detlnb));
                           prmt3.setString(5, rSet2.getString("Drug_ID").trim());
                           prmt3.setString(6, rSet2.getString("Quantity"));
                           prmt3.setString(7, rSet2.getString("Order_Unit"));
                           prmt3.setString(8, "");
                           prmt3.setString(9, rSet2.getString("Use_Once"));
                           prmt3.setString(10, rSet2.getString("Use_Dosage"));
                           prmt3.setString(11, rSet2.getString("Use_By"));
                           prmt3.setString(12, rSet2.getString("Use_Discrip"));
                           prmt3.setString(13, rSet2.getString("Use_Frequ"));
                           prmt3.setString(14, rSet2.getString("Use_Days"));
                           prmt3.setString(15, rSet2.getString("Use_Try"));
                           prmt3.setString(16, "");
                           prmt3.setString(17, String.valueOf(rSet2.getInt("Self_Provide")));
                           prmt3.setString(18, "");
                           prmt3.setString(19, "");
                           prmt3.setString(20, rSet2.getString("Price"));

                           try {
                              prmt3.executeUpdate();
                              conn.commit();
                           } catch (Exception var30) {
                              conn.rollback();
                           }
                        }
                     }

                     prmt3.close();
                     if(detlnb > 0) {
                        try {
                           prmt2.execute();
                           conn.commit();
                        } catch (Exception var29) {
                           OutMsg.println("提交失败：事务回滚");
                           OutMsg.println(var29);
                           conn.rollback();
                        }
                     } else {
                        OutMsg.println("未读到处方明细记录");
                     }

                     prmt2.close();
                     rSet2.close();
                     statement2.close();
                     conn.close();
                  }
                  break;
               case 2:
                  OutMsg.println("标准：处方退费：cfxh=\'" + cfxh + "\' patid=\'" + patid + "\'");
                  (new Thread(new CancelOrder(cfxh, patid))).start();
                  break;
               case 3:
                  OutMsg.println("标准：患者到窗口：cfxh=\'" + cfxh + "\' patid=\'" + patid + "\'" + " fyckh=" + windowNO);
                  break;
               case 4:
                  OutMsg.println("标准：发药完成：cfxh=\'" + cfxh + "\' patid=\'" + patid + "\' fyckh=\'" + windowNO + "\'");
                  (new Thread(new DispFinishT(patid, cfxh, his_operater))).start();
               }

               if(topID > 0) {
                  for(int var35 = topID + 1; var35 < TopID; ++var35) {
                     String var37 = String.valueOf(var35);
                     if("\'\'".equals(noReadID)) {
                        noReadID = "\'" + var37 + "\'";
                     } else {
                        noReadID = noReadID + ",\'" + var37 + "\'";
                     }
                  }
               }

               if(TopID > topID) {
                  topID = TopID;
               } else {
                  String var36 = String.valueOf(TopID);
                  noReadID = noReadID.replace("\'" + var36 + "\',", "").replace(",\'" + var36 + "\'", "").replace("\'" + var36 + "\'", "\'\'");
               }
            }

            rSet.close();
            e.close();
         } catch (Exception var34) {
            OutMsg.println("标准：ERROR:读处方异常");
            OutMsg.println(var34);
            this.connState = false;
         }

         try {
            Thread.sleep((long)getWaitTime());
         } catch (InterruptedException var28) {
            var28.printStackTrace();
         }
      }
   }
}
